<!DOCTYPE html>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<link href="https://fonts.googleapis.com/css?family=Roboto" rel="stylesheet">
<link rel="stylesheet" type="text/css" href="Curriculum.css">
<title>Curriculum</title>
</head>
<body>
<div class="centro">
  <h1 class="frase1">
    Manual Git
  </h1>
<div class="perfil">
  <img src="git4.jpg" style="padding-left:20%">
</div>
<div class="datos">
   <p><a href="#1">1. Qué es Git</a></p>
   <p><a href="#2">2. Instalación Git</a></p>
   <p><a href="#3">3. Configuración Git</a></p>
   <p><a href="#4">4. Crear un repositorio</a></p>
   <p><a href="#5">5. Clonar repositorios</a></p>
   <p><a href="#6">6. Primeros pasos con git</a></p>
   <p><a href="#7">7. Creación y gestión de ramas</a></p>
   <p><a href="#8">8. Resolución de conflictos</a></p>
   <p><a href="#9">9. Etiquetas</a></p>
</div>
<div class="contexto">
<h1 id="1">Qué es Git</h1>
<pre>Git, es un software de control de versiones diseñado por Linus Torvalds.
La pregunta es ¿qué es control de versiones? Pues bien, se define como control
de versiones a la gestión de los diversos cambios que se realizan sobre los
elementos de algún producto o una configuración del mismo es decir a la
gestión de los diversos cambios que se realizan sobre los elementos de algún
producto o una configuración, y para los que aún no les queda claro del todo,
control de versiones es lo que se hace al momento de estar desarrollando un
software o una página web. Exactamente es eso que haces cuando subes y actualizas
tu código en la nube, o le añades alguna parte o simplemente le editas cosas
que no funcionan como deberían o al menos no como tú esperarías.
</pre>
</div>
<div class="contexto">
<h1 id="2">Instalación Git</h1>
<pre>Si estás en una distribución basada en Debian como Ubuntu, prueba con apt-get:
$ apt-get install git</pre>
</div>
<div class="contexto">
<h1 id="3">Configuración Git</h1>
<pre>Tu identidad

Lo primero que deberías hacer cuando instalas Git es establecer tu nombre de
usuario y dirección de correo electrónico. Esto es importante porque las
 confirmaciones de cambios (commits) en Git usan esta información,
  y es introducida de manera inmutable en los commits que envías:

$ git config --global user.name "John Doe"
$ git config --global user.email johndoe@example.com

De nuevo, sólo necesitas hacer esto una vez si especificas la opción --global,
ya que Git siempre usará esta información para todo lo que hagas en ese sistema.
Si quieres sobrescribir esta información con otro nombre o dirección de correo
para proyectos específicos, puedes ejecutar el comando sin la opción --global
cuando estés en ese proyecto.
</pre>
</div>
<div class="contexto">
<h1 id="4">Crear un repositorio</h1>
<pre>Paso1: Selecciona la opcion "New Project"
Paso2: Selecciona las opciones correspondientes para configuar el proyecto
Paso3: Rellena la información del proyecto:
	-Nombre
	-Descripcion
	-Visibilidad
Paso4: Crear el proyecto
</pre>
</div>
<div class="contexto">
<h1 id="5">Clonar un repositorio:</h1>
<p>Si deseas obtener una copia de un repositorio Git existente —por ejemplo,
un proyecto en el que te gustaría contribuir— el comando que necesitas es git clone. Si estás familizarizado con otros sistemas de control de versiones como Subversion, verás que el comando es clone y no checkout. Es una distinción importante, ya que Git recibe una copia de casi todos los datos que tiene el servidor. Cada versión de cada archivo de la historia del proyecto es descargado cuando ejecutas git clone. De hecho, si el disco de tu servidor se corrompe, puedes usar cualquiera de los clones en
cualquiera de los clientes para devolver al servidor al estado en el que estaba cuando fue clonado
(puede que pierdas algunos hooks del lado del servidor y demás, pero toda la información versionada estaría ahí —véase el Capítulo 4 para más detalles—).
<br>
Puedes clonar un repositorio con git clone [url]. Por ejemplo, si quieres clonar la librería Ruby llamada Grit, harías algo así:
<br>
$ git clone git://github.com/schacon/grit.git
<br>
Esto crea un directorio llamado "grit", inicializa un directorio .git en su interior, descarga toda la información de ese repositorio, y saca una copia de trabajo de la última versión. Si te metes en el nuevo directorio grit, verás que están los archivos del proyecto, listos para ser utilizados. Si quieres clonar el repositorio a un directorio con otro nombre que no sea grit, puedes especificarlo con la siguiente opción de línea de comandos:
<br>
$ git clone git://github.com/schacon/grit.git ejemplo
<br>
Ese comando hace lo mismo que el anterior, pero el directorio de destino se llamará ejmplo.
<br>
Git te permite usar distintos protocolos de transferencia. El ejemplo anterior usa el protocolo git://, pero también te puedes encontrar con http(s):// o usuario@servidor:/ruta.git, que utiliza el protocolo de transferencia SSH. En el Capítulo 4 se introducirán todas las opciones disponibles a la hora de configurar el acceso a tu repositorio Git, y las ventajas e inconvenientes de cada una.
</p>
</div>
<div class="contexto">
<h1 id="6">Primeros pasos de git</h1>
<pre>

INSTALACIÓN DE GIT

apt-get install git gitg

CONFIGURACIÓN

Tres nivells de configuración:

A nivel de usuario:
git config --global user.name "Your Name"
git config --global user.email "your_email@whatever.com"

A nivel de proyecto:
git config user.email "your_other_email@whatever.com"

A nivel de sistema

Para listar variables
git config --list

CREACIÓN DEL PROYECTO

mkdir hello
cd hello
Escrivimos el programa HelloWorld en bash hello.sh:
	#!/bin/sh
	echo "Hello world!"

CREACIÓN DEL REPOSITORIO Y COMPROBACIÓN DE SU ESTADO

git init
git status

(Esto nos crea el directori .git, es donde se guarda todo. Explorarlo!!)

PONIENDO LOS CAMBIOS EN EL STAGE (STAGING)

git add hello.sh
git status

PONIENDO LOS CAMBIOS EN EL REPOSITORIO LOCAL (COMITTING)

git commit -m "Add hello world"
git status

HACIENDO COMMIT DE LOS CAMBIOS

Editamos el fichero
	#!/bin/sh
	# Says hello
	echo "Hello world!"
git status

git add hello.sh
git commit -m "Add comment"

HACIENDO UN CAMBIO EN MÁS DE UN FICHERO

Crear los ficheros goodbye.sh y thanks.sh (con sus echo correspondientes)
Los añadimos, los dos ficheros serán parte del siguiente commit:

git add goodbye.sh thanks.sh

o

git add .

Si no ponemos la opción -m(añadir comentario), debería abrirse un editor y pedir un comentarioProvem ara de no posar l'opció -m:

git commit

Pondremos:

Add more simple scripts talking to world

HACIENDO MÁS DE UN CAMBIO EN UN ÚNICO FICHERO

Editamos el fichero goodbye.sh poniendo un comentario y lo ponemos en stage

git add goodbye.sh
git status

Volvemos a editar el fichero goobye.sh poniendo más exclamaciones

git status

Hacemos commit del primer cambio.

git commit -m "Add comment"

Ahora añadimos y hacemos commit del segundo cambio.

git add goodbye.sh
git commit -m "Put more emphasis"

CONSULTAR HISTÓRICO

Probar gitg:

git log
git log --pretty=oneline
git log --pretty=oneline --max-count=2
git log --pretty=oneline --since='5 minutes ago'
git log --pretty=oneline --until='5 minutes ago'
git log --pretty=oneline --author=<your name>
... (man git log)

VER LOS OBJETOS

git cat-file -t <hash>
git cat-file -p <hash>

IR AL PASADO

git checkout <hash>	(ponemos el hash del 1er commit)

Para volver a la última versión

git checkout master
</pre>
</div>
<div class="contexto">
<h1 id="7">Creación y gestión de ramas.</h1>
<p>Paso 1: Creamos la rama con el comando git branch nombre_rama o en el clipse utilizamos la opción de click derecho
  crear rama.
  Paso 2: Para cambiar de rama y trabajar en ella debemos usar el comando git checkout nombre_rama o doble click en la rama (en caso de estar usando eclipse).
  Paso 3: Para guardar las modificaciones en la rama procedemos a usar el comando git merge o un click derecho merge.
</p>
</div>


<div class="contexto">
<h1 id="8">Resolución de conflictos.</h1>
<p>
  Intentamos actualizar un archivo pero otro usuario ha modificado la misma linia, en este susodicho caso git o el programa eclipse (dependiendo de lo que usemos), nos mostrara un error,
  para solucionar este error procedemos a lo siguiente

  Paso 1: Abrimos la herramienta de eclipse "git merge tool" o usaremos el comando git merge para fusionar todos los cambios y asi solucionar los problemas de conflictos.
</p>
</div>

<div class="contexto">
<h1 id="9">Etiquetas.</h1>
<p>
  Las etiquetas de git nos permiten crear "subramas" inaltarbles para almacenar archivos, es decir que nos permitirá crear versiones dentro las ramas.
</p>
</div>
</body>
</html>
